/*
 * Copyright (C) 2002 by Jirka Kosina <jikos@jikos.cz>
 * This program is free software under GPL.
 * See ../COPYING for detailed info
 */

#include "japach.h"

/* resembling is_in_cage() */

int is_in_cgi_path(char *filename)
{
	struct cgidirs *pom;
	char *pom1;
	int found = 0;

	pom = conf.cgi_dirs;
	while ((!found) && (pom->next)) {
		if (strstr(filename, pom->next->name) == filename)
			return (1);
		else
			pom = pom->next;
	}
	return (0);
}

/* first test if given reaquest is going to be a CGI script.
 * if not, return CGI_NOCGI.
 * Otherwise if it really can be run returns CGI_OK, in other
 * cases CGI_ERR
 * Huh, why is this comment longer than the body of the function? ;)
 */

int if_cgi_then_ok(char *filename)
{
	if (!(is_in_cgi_path(filename)))
		return CGI_NOCGI;
	if (access(filename, X_OK) == -1)
		return CGI_ERR;
	else
		return CGI_OK;
}

char *cgi_add_env_var(char *name, char *value)
{
	int len;
	char *result;

	len = strlen(name) + 2;
	if (value) {		/* if quesry string was empty, we will have nice segfault probably */
		len += strlen(value);
	}
	result = (char *) malloc(sizeof(char) * len);
	sprintf(result, "%s=%s", name, value ? value : "");
	return result;

}

char **cgi_get_environment()
{
	char **p1, **p2;

	p1 = p2 = (char **) malloc(sizeof(char *) * MAX_ENVIRON_VARS);


	*p1++ = cgi_add_env_var("SERVER_NAME", client.requested_host);
	*p1++ =
	    cgi_add_env_var("SERVER_SOFTWARE", FULL_SERVER_SOFTWARE_NAME);
	*p1++ = cgi_add_env_var("SERVER_PROTOCOL", client.http_version);
	*p1++ = cgi_add_env_var("REMOTE_ADDR", client.host_name);
	*p1++ = cgi_add_env_var("REQUEST_METHOD", client.method);	/* GET */
	*p1++ = cgi_add_env_var("SCRIPT_NAME", client.req_url);
	*p1++ = cgi_add_env_var("SCRIPT_FILENAME", client.getfile);
	*p1++ =
	    cgi_add_env_var("QUERY_STRING", client.cgi_get_query_string);
	*p1++ = 0;

	return p2;
}
